<?php
/*
Plugin Name: AHCommentCentral
Plugin URI: http://hoogervorst.ca/arthur
Description: This plugin allows users to mass close/open comments and trackbacks.
Version: 0.4.2
Author: Arthur Hoogervorst
Author URI: http://hoogervorst.ca/arthur

    ============================================================================
    GPL HEADER FOLLOWS:
    ============================================================================
    Copyright 2006  Arthur Hoogervorst  (site: see above.)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
    ============================================================================    
*/



/* Initial stub for Wordpress plugin */


function ahi_comments_control_options(){
  if (function_exists('add_options_page')){
     		add_options_page('Comment Central', 
			 'Comment Central',
			 8, 
			 basename(__FILE__), 'ahi_comments_control_conf'); 
  }
}

/* Initialize the main array */
$ahi_insidious = array();

/* At this stage, nothing used yet */
$ahi_insidious['excludeditems'] = get_option('ahi_cc_excluded_posts');
$ahi_insidious['user_submitted'] = '';
$ahi_insidious['error'] = FALSE;
$ahi_insidious['message'] = '';

/* AH073106-- */
$xsite_url = get_bloginfo('wpurl') . '/wp-admin';
$version_array = explode('.', get_bloginfo('version'));
$version_two_or_higher = FALSE;

if ($version_array[0] >= 2) { 
   $version_two_or_higher = TRUE;
}



// Check the post variables. One extra reserved for autoprocessing.
if ($_POST['simple-cc'] == 'Update') {
  $ahi_insidious['user_submitted'] = 'simple';
} 

if ($_POST['advanced-cc'] == 'Update') {
  $ahi_insidious['user_submitted'] = 'advanced';
} 

if ($_POST['daterange-cc'] == 'Update') {
  $ahi_insidious['user_submitted'] = 'daterange';  
}

if ($_POST['automated-cc'] == 'Update') {
  $ahi_insidious['user_submitted'] = 'automated';  
}

// AH073106 --
if ($_POST['postids-cc'] == 'Update') {
  $ahi_insidious['user_submitted'] = 'post-ids';  
}

function printMessage($err, $msg){
  global $ahi_insidious, $version_two_or_higher;
  
  $p = ($err == FALSE ? 'updated ' : 'error ');
  
  // AH080106 Only use 'updated'!
  if (!$version_two_or_higher) {
    $p = 'updated ';
  }
  
    
  if (!empty($msg)) {
    echo "<div id='message' class='" . 
	  $p .
	   "fade'><p><strong>". $msg . "</strong></p></div>";
    $ahi_insidious['error'] = FALSE;
	$ahi_insidious['message'] = '';	        
	
  }
}

// This is the actual call to the main screen.
function ahi_comments_control_conf(){ 
  global $ahi_insidious;    
  if ($ahi_insidious['user_submitted'] <> '') {
      ParseStuff($ahi_insidious['user_submitted']);
      printMessage($ahi_insidious['error'], 
	  $ahi_insidious['message']);      
      $ahi_insidious['user_submitted'] = '';
  } 
  $stat = GetStatisticsData();
  PrintForm($stat); 
}



function GetStatisticsData(){
  global $wpdb, $version_two_or_higher;

  if ($version_two_or_higher == TRUE) {
    $sql = "select count(*) as number, post_status,";
    $sql = $sql . " comment_status, ping_status,";
    $sql = $sql . " sum(comment_count) as comment_count";
    $sql = $sql . " from " . $wpdb->posts ; /* AH073106 */
    $sql = $sql . " group by post_status, comment_status, ping_status";
    $sql = $sql . " order by post_status";
  } else {
    // Degrade nicely to lower versions.
    // AH080106 -- Use 'nice' MySQL aliases.
	$sql = "select count(p.ID) as number, p.post_status as post_status,";
	$sql = $sql . "	p.comment_status as comment_status, p.ping_status as ping_status,";
	$sql = $sql . " count(c.comment_post_id) as comment_count";
	$sql = $sql . " from " .$wpdb->posts . " p";
	$sql = $sql . " left outer join " . $wpdb->comments . " c on";
	$sql = $sql . " (c.comment_post_ID = p.ID)";
	$sql = $sql . " group by p.post_status,";
	$sql = $sql . " p.comment_status, p.ping_status";
	$sql = $sql . " order by p.post_status";
  }
  
  $i_array = $wpdb->get_results($sql);

  $s = ''; $i = 1;
  foreach($i_array as $statdata) {
    
    $s = $s . '<tr>' .
         '<td' . ( ($i % 2 <> 0) ? ' class="alternate"' : '') . '>' 
		   . (empty($statdata->number) ? '0' : $statdata->number) .'</td>' .
		 '<td'. ( ($i % 2 <> 0) ? ' class="alternate"' : '') . '>' 
		   . (empty($statdata->post_status) ? '&nbsp;' : $statdata->post_status) .'</td>' . 
		 '<td' . ( ($i % 2 <> 0) ? ' class="alternate"' : '') . '>' 
		   . (empty($statdata->comment_status)? '&nbsp;' : $statdata->comment_status) .'</td>' .
		 '<td'. ( ($i % 2 <> 0) ? ' class="alternate"' : '') . '>' 
		   . (empty($statdata->comment_status)? '&nbsp;' : $statdata->ping_status) .'</td>' .		 
		 '<td'. ( ($i % 2 <> 0) ? ' class="alternate"' : '') . '>' 
		   . (empty($statdata->comment_count)? '0' : $statdata->comment_count) .'</td>' .		 
	  '</tr>';
	$i++;
  }
  $s = '<table>' .
     '<tr><th>Number</th><th>PostStatus</th><th>Commentstatus</th><th>Pingstatus</th><th>CommentCount</th>' .
      $s  . 
	  '</table>';
  if ($version_two_or_higher == TRUE) {
  	$s = $s . '<p><small><sup>1</sup> Statistics collected over one table (WP 2.0 or higher).</small></p>';
  } else {
	$s = $s . '<p><small><sup>1</sup> Statistics collected over two tables (WP 1.x).</small></p>';
  }
  return $s;  
}

/* Simple comments query */
function DoSimpleComments($actionComments){
  global $wpdb;
  $res = -1;  
  if (($actionComments > 0) && ($actionComments < 3)) {
   	  switch($actionComments) {
	    case 1 :
	      $smut = 'open';
		  break;
		case 2 :
		  $smut = 'closed';
		  break;  
	  } 
	  
	  $sql = "UPDATE " . $wpdb->posts;
	  $sql = $sql . ' SET';
	  $sql = $sql . " comment_status = '". $smut ."'";
	  $sql = $sql . " WHERE comment_status <> '" . $smut ."'";
	  
	  
	  // Launch query...
	  $res = $wpdb->query($sql);
	  
  }
  return $res;  
}

/* Simple Pings query */
function DoSimplePings($actionPings){
  global $wpdb;
  
  $res = -1;
  if (($actionPings > 0) && ($actionPings < 3)) {    
	  switch($actionPings) {
	    case 1 :
	      $smet = 'open';
		  break;
		case 2 :
		  $smet = 'closed';
		  break;  
	  } 
	  
	  $sql = "UPDATE " . $wpdb->posts;
	  $sql = $sql . ' SET';
	  $sql = $sql . " ping_status = '" . $smet. "'";
	  $sql = $sql . " WHERE ping_status <> '" . $smet ."'";
	  
	  
	  // Launch query...
	  $res = $wpdb->query($sql);  
  }
  return $res;
}


function DoDateRangeStuff($day, $month, $year){
  $s = '';
  if (checkdate($month, $day, $year)) {
    $s = date('Y-m-d',  strtotime("{$year}-{$month}-{$day}"));
  }
  return $s;
}

function VerifyPostIDS($astring) {
  
  // The server returns a string, so, we're going to break it up
  // first into an array.
  $array = explode(',', $astring);
  $s = '';
  foreach($array as $v) {
    $i = trim($v);
    // verify if this one is numeric...
    if (is_numeric($i)) {
	  $s[] = $i;
	} else {
	  $s = '';
	  break;
	}
  }
  return $s; 
}

function DoPostIDSComments($array, $dotype) {
  global $wpdb;
  
  $res = -1;
  
  if (!empty($array)) {
      
	  $sinterklaas = implode(',', $array);
      
	  if (($dotype > 0) && ($dotype < 3)) {
	     switch ($dotype) {
		   case 1 : 
		     $smet = 'open';
		     break;
		   case 2 :
		     $smet = 'closed';
		     break;
	     }
		 
		 /// Start building the SQL statement...
		$sql = "UPDATE " . $wpdb->posts;
		$sql = $sql . ' SET';
		$sql = $sql . " comment_status = '" . $smet . "'";
		$sql = $sql . " WHERE comment_status <> '" . $smet ."'";
		$sql = $sql . " AND ID in (" . $sinterklaas . ")";
		
		$res = $wpdb->query($sql);  			 	     
	  }  
  }
  return $res;
}

function DoPostIDSPings($array, $dotype) {
  global $wpdb;
  
  $res = -1;
  
  if (!empty($array)) {
      
	  $sinterklaas = implode(',', $array);
      
	  if (($dotype > 0) && ($dotype < 3)) {
	     switch ($dotype) {
		   case 1 : 
		     $smet = 'open';
		     break;
		   case 2 :
		     $smet = 'closed';
		     break;
	     }
		 
		 /// Start building the SQL statement...
		$sql = "UPDATE " . $wpdb->posts;
		$sql = $sql . ' SET';
		$sql = $sql . " ping_status = '" . $smet . "'";
		$sql = $sql . " WHERE ping_status <> '" . $smet ."'";
		$sql = $sql . " AND ID in (" . $sinterklaas . ")";

		$res = $wpdb->query($sql);  			 	     
	  }  
  }  
  return $res;
}


/* Date Range Comments query */
function DoDateRangeComments($date1, $date2, $dotype){
  global $wpdb;
  
  $res = -1;
  
  if (($dotype > 0) && ($dotype < 3)) {
     switch ($dotype) {
	   case 1 : 
	     $smet = 'open';
	     break;
	   case 2 :
	     $smet = 'closed';
	     break;
	}
	
	$sql = "UPDATE " . $wpdb->posts;
	$sql = $sql . ' SET';
	$sql = $sql . " comment_status = '" . $smet . "'";
	$sql = $sql . " WHERE comment_status <> '" . $smet ."'";
	$sql = $sql . " AND post_date >= '". $date1 ."'";	
	$sql = $sql . " AND post_date <= '". $date2 ."'";		
	
	$res = $wpdb->query($sql);  	
  }
  return $res;
}

/* Date Range Pings Query */
function DoDateRangePings($date1, $date2, $dotype){
  global $wpdb;  
  
  $res = -1;
  
  if (($dotype > 0) && ($dotype < 3)) {
     switch ($dotype) {
	   case 1 : 
	     $smet = 'open';
	     break;
	   case 2 :
	     $smet = 'closed';
	     break;
	}
	
	$sql = "UPDATE " . $wpdb->posts;
	$sql = $sql . ' SET';
	$sql = $sql . " ping_status = '" . $smet . "'";
	$sql = $sql . " WHERE ping_status <> '" . $smet ."'";
	$sql = $sql . " AND post_date >= '". $date1 ."'";	
	$sql = $sql . " AND post_date <= '". $date2 ."'";		
	
	$res = $wpdb->query($sql);  	
  }
  return $res;
}

/* Prepares string for Last xxx query */
function prepareDateDates($number, $type) {
  switch($type) {
    case 0 :
      $s = " where post_date < CURDATE() AND post_date >= ".
           " DATE_SUB(CURDATE(), INTERVAL " . $number . " DAY)";
	  break;
	case 1 :
      $s = " where post_date < CURDATE() AND post_date >= ".
           " DATE_SUB(CURDATE(), INTERVAL " . $number * 7 . " DAY)";
	  break;
	case 2 :
      $s = " where post_date < CURDATE() AND post_date >= ".
           " DATE_SUB(CURDATE(), INTERVAL " . $number . " MONTH)";
	  break;
	case 3 :
      $s = " where post_date < CURDATE() AND post_date >= ".
           " DATE_SUB(CURDATE(), INTERVAL " . $number . " YEAR)";
	  break; 
	default :
      $s = " where post_date < CURDATE() AND post_date >= ".
           " DATE_SUB(CURDATE(), INTERVAL " . $number . " DAY)";
  }    
  return $s;
}

/* Updates an amount of posts */
function DoAdvancedComments($doaction, $number, $type){
  global $wpdb;
  
  $res = -1;
     
  if (($doaction > 0) && ($number > 0)) {
    if ($doaction == 1) {
	  $sm = 'open'; 
	}else {
	  $sm = 'closed';
	}
	if ($type == 4) {
	  $s = FindLastPosts($number);
	  if ($s <> '') {
		  $sql1 = 'UPDATE ' . $wpdb->posts;
		  $sql1 = $sql1 . " SET comment_status = '" . $sm . "'";
		  $sql1 = $sql1 . " WHERE id in (" . $s .") ";
		  $sql1 = $sql1 . " AND comment_status <> '".$sm ."'";
		  
		  $wpdb->query($sql1);	    
      }
	} else {
	
	    $sql2 = prepareDateDates($number, $type);
	    if (!empty($sql2)) {
		  $sql1 = 'UPDATE ' . $wpdb->posts;
		  $sql1 = $sql1 . "  SET comment_status = '" . $sm . "'";
		  $sql1 = $sql1 . $sql2;
		  $sql1 = $sql1 . " AND comment_status <> '".$sm ."'";

	
		  
		  $res = $wpdb->query($sql1);
		}
	}
  }
  return $res;
}

/* Helper query */
function FindLastPosts($numberofdays){
  global $wpdb;
  $stp = '';
  if ($numberofdays > 0) {
    // run the query...
    $sql = 'SELECT id FROM ' .$wpdb->posts;
    $sql = $sql . " WHERE  post_status = 'publish'";
    $sql = $sql . " order by id DESC  limit " . $numberofdays;
    
    $data = $wpdb->get_col($sql);
    
    if (!empty($data))
	   $stp = implode(',', $data);

  }
  return $stp;
}

/* Do Pings query */
function DoAdvancedPings($doaction, $number, $type){
  global $wpdb;
  
  $res = -1;
  
  if (($doaction > 0) && ($number > 0)) {
    if ($doaction == 1) {
	  $sm = 'open'; 
	}else {
	  $sm = 'closed';
	}
	
	
	if ($type == 4) {
	  $s = FindLastPosts($number);
	  if ($s <> '') {
		  $sql1 = 'UPDATE ' . $wpdb->posts;
		  $sql1 = $sql1 . " SET ping_status = '" . $sm . "'";
		  $sql1 = $sql1 . " WHERE id in (" . $s .") ";
		  $sql1 = $sql1 . " AND ping_status <> '".$sm ."'";
		  $res = $wpdb->query($sql1);	    
      }
	} else {
	    $sql2 = prepareDateDates($number, $type);
	    if (!empty($sql2)) {
		  $sql1 = 'UPDATE ' . $wpdb->posts;
		  $sql1 = $sql1 . "  SET ping_status = '" . $sm . "'";
		  $sql1 = $sql1 . $sql2;
		  $sql1 = $sql1 . " AND ping_status <> '".$sm ."'";
		  
		  $res = $wpdb->query($sql1);
		}
	}
  }
  return $res;
}

/* To be continued... */
function PrintAuto() {
  //
}

function PrintForm($statistics = '') {
global $xsite_url;
  
$xsite_comments = $xsite_url . '/edit-comments.php';
$xsite_posts = $xsite_url . '/edit.php';

echo <<<END
<!--- Start of HTML form -->
  <div class="wrap">
  <h2>Hi!</h2>
  <p>Go to <a href="#bookmark_statistics"><strong>statistics</strong></a>,
  Mass close/open <a href="#bookmark_everything"><strong>Everything&trade;</strong></a>, 
  Close or open the <a href="#bookmark_bylastnumber"><strong>last number</strong></a> of posts,
  select your own <a href="#bookmark_daterange"><strong>date range</strong></a> specifics or
  manage your <a href="#bookmark_individualposts"><strong>posts individually</strong></a>!
  !
  </p>
  <p>Or review your recently added <a href="{$xsite_comments}"><strong>comments</strong></a>
   or <a href="{$xsite_posts}"><strong>posts</strong></a>.
  </p>
 <a name="bookmark_statistics"><h2>Statistics</h2></a>
 <p>Current statistics<sup>1</sup>:
 </p>
 <p>{$statistics}
 </p> 
<h2>Manually manage comments</h2>
<form method="post">
  <a name="bookmark_everything"><h3>Everything&trade;</h3></a>
  <p>Here you can mass close / open comments or trackbacks.</p>
  <fieldset>
  <table>
    <tbody>
      <tr>
        <td><strong>All comments:</strong></td>
        <td><input name="simple_comments" checked="checked"
 value="0" type="radio">&nbsp;<label>No
action</label></td>
        <td><input name="simple_comments" value="1"
 type="radio">&nbsp;<label>Open</label></td>
        <td> <input name="simple_comments" value="2"
 type="radio">&nbsp;<label>Close</label> </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td><strong>All pings:</strong></td>
        <td><input name="simple_pings" checked="checked"
 value="0" type="radio">&nbsp;<label>No
action</label></td>
        <td><input name="simple_pings" value="1"
 type="radio">&nbsp;<label>Open</label></td>
        <td> <input name="simple_pings" value="2"
 type="radio">&nbsp;<label>Close</label> </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td><span class="submit"> <input
 name="simple-cc" value="Update" type="submit"></span></td>
      </tr>
    </tbody>
  </table>
  </fieldset>
</form>
<form method="post"><br>
  <a name="bookmark_bylastnumber"><h3>By Last number of...</h3></a>
  <p>You can also choose to close or open comments or pings based
on the number of posts/days you provide:</p>
  <p>
  <fieldset>
  <table>
    <tbody>
      <tr>
        <td><strong>Comments:</strong></td>
        <td>
        <select name="comment-choice">
        <option value="0">No action for</option>
        <option value="1">Open</option>
        <option value="2">Close</option>
        </select>
        </td>
        <td>all <span style="text-decoration: underline;">comments</span>
for the last</td>
        <td><input size="4" maxlength="2"
 name="comment-amount" value="5"></td>
        <td>
        <select name="comment-unit">
        <option value="4">Posts</option>        
        <option value="0">Days</option>
        <option value="1">Weeks</option>
        <option value="2">Months</option>
        <option value="3">Years</option>
        </select>
        </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td><strong>Pings:</strong></td>
        <td>
        <select name="ping-choice">
        <option value="0">No action for</option>
        <option value="1">Open</option>
        <option value="2">Close</option>
        </select>
        </td>
        <td>all <span style="text-decoration: underline;">pings</span>
for the last</td>
        <td><input size="4" maxlength="2"
 name="ping-days" value="5"></td>
        <td>
        <select name="ping-unit">
        <option value="4">Posts</option>                
        <option value="0">Days</option>
        <option value="1">Weeks</option>
        <option value="2">Months</option>
        <option value="3">Years</option>
        </select>
        </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td><span class="submit"> <input
 name="advanced-cc" value="Update" type="submit"></span></td>
      </tr>
    </tbody>
  </table>
  </fieldset>
  </p>
</form>
<form method="post">
  <a name="bookmark_daterange"><h3>By Daterange...</h3></a>
  <p>You can choose to close or open posts/pings between two
specified dates. </p>
  <fieldset>
  <table>
    <tbody>
      <tr>
        <td><span style="font-weight: bold;">Comments:</span></td>
        <td>
        <select name="date-choice">
        <option value="0">No action for</option>
        <option value="1">Open</option>
        <option value="2">Close</option>
        </select>
        </td>
        <td>all comments from</td>
        <td><input maxlength="2" size="2"
 name="date-day1"></td>
        <td>
        <select name="date-month1">
        <option value="1">Jan</option>
        <option value="2">Feb</option>
        <option value="3">Mar</option>
        <option value="4">Apr</option>
        <option value="5">May</option>
        <option value="6">June</option>
        <option value="7">July</option>
        <option value="8">Aug</option>
        <option value="9">Sep</option>
        <option value="10">Oct</option>
        <option value="11">Nov</option>
        <option value="12">Dec</option>
        </select>
        </td>
        <td>
        <select name="date-year1">
        <option value="2000">2000</option>
        <option value="2001">2001</option>
        <option value="2002">2002</option>
        <option value="2003">2003</option>
        <option value="2004">2004</option>
        <option value="2005">2005</option>
        <option value="2006" selected="selected">2006</option>
        <option value="2007">2007</option>
        <option value="2008">2008</option>
        <option value="2009">2009</option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        </select>
        </td>
        <td>&nbsp;to </td>
        <td><input maxlength="2" size="2"
 name="date-day2"></td>
        <td>
        <select name="date-month2">
        <option value="1">Jan</option>
        <option value="2">Feb</option>
        <option value="3">Mar</option>
        <option value="4">Apr</option>
        <option value="5">May</option>
        <option value="6">June</option>
        <option value="7">July</option>
        <option value="8">Aug</option>
        <option value="9">Sep</option>
        <option value="10">Oct</option>
        <option value="11">Nov</option>
        <option value="12">Dec</option>
        </select>
        </td>
        <td>
        <select name="date-year2">
        <option value="2000">2000</option>
        <option value="2001">2001</option>
        <option value="2002">2002</option>
        <option value="2003">2003</option>
        <option value="2004">2004</option>
        <option value="2005">2005</option>
        <option value="2006" selected="selected">2006</option>
        <option value="2007">2007</option>
        <option value="2008">2008</option>
        <option value="2009">2009</option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        </select>
        </td>
        <td></td>
      </tr>
      <tr>
        <td><span style="font-weight: bold;">Pings:</span></td>
        <td>
        <select name="pdate-choice">
        <option value="0">No action for</option>
        <option value="1">Open</option>
        <option value="2">Close</option>
        </select>
        </td>
        <td>all pings from</td>
        <td><input maxlength="2" size="2"
 name="pdate-day1"></td>
        <td>
        <select name="pdate-month1">
        <option value="1">Jan</option>
        <option value="2">Feb</option>
        <option value="3">Mar</option>
        <option value="4">Apr</option>
        <option value="5">May</option>
        <option value="6">June</option>
        <option value="7">July</option>
        <option value="8">Aug</option>
        <option value="9">Sep</option>
        <option value="10">Oct</option>
        <option value="11">Nov</option>
        <option value="12">Dec</option>
        </select>
        </td>
        <td>
        <select name="pdate-year1">
        <option value="2000">2000</option>
        <option value="2001">2001</option>
        <option value="2002">2002</option>
        <option value="2003">2003</option>
        <option value="2004">2004</option>
        <option value="2005">2005</option>
        <option value="2006" selected="selected">2006</option>
        <option value="2007">2007</option>
        <option value="2008">2008</option>
        <option value="2009">2009</option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        </select>
        </td>
        <td>&nbsp;to </td>
        <td><input maxlength="2" size="2"
 name="pdate-day2"></td>
        <td>
        <select name="pdate-month2">
        <option value="1">Jan</option>
        <option value="2">Feb</option>
        <option value="3">Mar</option>
        <option value="4">Apr</option>
        <option value="5">May</option>
        <option value="6">June</option>
        <option value="7">July</option>
        <option value="8">Aug</option>
        <option value="9">Sep</option>
        <option value="10">Oct</option>
        <option value="11">Nov</option>
        <option value="12">Dec</option>
        </select>
        </td>
        <td>
        <select name="pdate-year2">
        <option value="2000">2000</option>
        <option value="2001">2001</option>
        <option value="2002">2002</option>
        <option value="2003">2003</option>
        <option value="2004">2004</option>
        <option value="2005">2005</option>
        <option value="2006" selected="selected">2006</option>
        <option value="2007">2007</option>
        <option value="2008">2008</option>
        <option value="2009">2009</option>
        <option value="2010">2010</option>
        <option value="2011">2011</option>
        <option value="2012">2012</option>
        </select>
        </td>
        <td></td>
      </tr>
      <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td><span class="submit"><input
 name="daterange-cc" value="Update" type="submit"></span></td>
      </tr>
    </tbody>
  </table>
  </fieldset>
</form>
<form method="post">
  <a name="bookmark_individualposts"><h3>By Individual post IDs</h3></a>
  <p>You can type in multiple IDs (separated by commas) in the
field below. (View your <a href="{$xsite_posts}"><strong>posts</strong></a> now 
 or view them in a <a href="{$xsite_posts}" target="_new"><strong>
 separate window</strong></a>).</p>
  <fieldset>
  <table>
    <tbody>
      <tr>
        <td><span style="font-weight: bold;">Post ID:</span></td>
        <td colspan="3" rowspan="1"><input
 size="40" name="posts-text"></td>
        <td></td>
      </tr>
      <tr>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
        <td></td>
      </tr>
      <tr>
        <td><strong>All comments:</strong></td>
        <td><input name="posts-comments" checked="checked"
 value="0" type="radio">&nbsp;<label>No
action</label></td>
        <td><input name="posts-comments" value="1"
 type="radio">&nbsp;<label>Open</label></td>
        <td> <input name="posts-comments" value="2"
 type="radio">&nbsp;<label>Close</label> </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td><strong>All pings:</strong></td>
        <td><input name="posts-pings" checked="checked"
 value="0" type="radio">&nbsp;<label>No
action</label></td>
        <td><input name="posts-pings" value="1"
 type="radio">&nbsp;<label>Open</label></td>
        <td> <input name="posts-pings" value="2"
 type="radio">&nbsp;<label>Close</label> </td>
        <td>&nbsp;</td>
      </tr>
      <tr>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td>&nbsp;</td>
        <td><span class="submit"> <input
 name="postids-cc" value="Update" type="submit"></span></td>
      </tr>
    </tbody>
  </table>
  </fieldset>
</form>
</div>
<div class ="wrap">
<p><small>This plugin &copy;2006 Arthur Hoogervorst. Thanks to: Alfons. You can find latest versions
at <a href="http://hoogervorst.ca/arthur/">www:hoogervorst.ca/arthur</a>.</small>
</p>
</div>
END;
}

function ParseStuff($aparseablestuff){
  global $ahi_insidious;
  
  
  switch ($aparseablestuff) {
    case 'simple'    :
      $res1 = DoSimpleComments($_POST['simple_comments']);
      $res2 = DoSimplePings($_POST['simple_pings']);
	  break;
	case 'advanced'  :
      $res1 = DoAdvancedComments($_POST['comment-choice'], 
	    $_POST['comment-amount'], $_POST['comment-unit']);
	  $res2 = DoAdvancedPings($_POST['ping-choice'], 
	    $_POST['ping-days'], $_POST['ping-unit']);	    
	    
	  break;
	case 'daterange' :
	
	  if (!empty($_POST['date-day1']) &&
	      !empty($_POST['date-day2']) &&
	     !empty($_POST['date-month1']) &&
		 !empty($_POST['date-month2']) &&
		 !empty($_POST['date-year1']) &&
		 !empty($_POST['date-year2'])) {
		  
		  $date1 = DoDateRangeStuff($_POST['date-day1'],
		    $_POST['date-month1'], $_POST['date-year1']);
		  $date2 = DoDateRangeStuff($_POST['date-day2'],
		    $_POST['date-month2'], $_POST['date-year2']);
		  
		  if (!empty($date1) && !empty($date2)) {
	        $res1 = DoDateRangeComments($date1, $date2, $_POST['date-choice']);
	      }
      }
	  if (!empty($_POST['pdate-day1']) &&
	     !empty($_POST['pdate-day2']) &&
	     !empty($_POST['pdate-month1']) &&
		 !empty($_POST['pdate-month2']) &&
		 !empty($_POST['pdate-year1']) &&
		 !empty($_POST['pdate-year2'])) {

		  $date1 = DoDateRangeStuff($_POST['pdate-day1'],
		    $_POST['pdate-month1'], $_POST['pdate-year1']);
		  $date2 = DoDateRangeStuff($_POST['pdate-day2'],
		    $_POST['pdate-month2'], $_POST['pdate-year2']);
	      
		  if (!empty($date1) && !empty($date2)) {
	        $res2 = DoDateRangePings($date1, $date2, $_POST['pdate-choice']);
	      }
      }
      
	  break;
	case 'post-ids' : /* AH073106 -- */
	  $arr = VerifyPostIDS($_POST['posts-text']);	  	  
	  if (!empty($arr)) {
	    $res1 = DoPostIDSComments($arr, $_POST['posts-comments']);
		$res2 = DoPostIDSPings($arr, $_POST['posts-pings']);	    
      }	  
	  break;
	case 'automated' : 
      break;
  }

  $s1 = '';  
  
  if (($res1 == 0) && ($res2 == 0)) {
    $ahi_insidious['error'] = FALSE;
	$s1 = 'Nothing updated..';	          
  } else {
	  if ($res1 > 0) {
	    $ahi_insidious['error'] = FALSE;
		$s1 = 'Comments succesfully updated...';	        
	  } else {
	    $ahi_insidious['error'] = True;	    
	    $s1 = '--  No comments were updated!';
      }
	  
	  if ($res2 > 0) {
	    $ahi_insidious['error'] = FALSE;
		$s1 = $s1 . '. Pings succesfully updated...';	        	      
	  } else {
	    $ahi_insidious['error'] = True;	    
	    $s1 = $s1 . '--  No pings were updated!';	    
 	}
  }
  $ahi_insidious['message'] = $s1; 
}

add_action('admin_menu', 'ahi_comments_control_options');

?>
